unit CoreClassesUnit;

interface

uses
  System.ComponentModel,
  System.Collections,
  Borland.Eco.Services,
  Borland.Eco.ObjectRepresentation,
  Borland.Eco.ObjectImplementation,
  Borland.Eco.UmlRt,
  Borland.Eco.UmlCodeAttributes;

type
  Person = class;
  [UmlElement('Package')]
  [EcoCodeGenVersion('1.0')]
  [UmlMetaAttribute('ownedElement', TypeOf(Person))]
  CoreClasses = class
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(CoreClasses))]
  [UmlCollection(TypeOf(Person))]
  [EcoAutoGenerated]
  IPersonList = interface
    function get_Count: Integer;
    function get_Item(index: Integer): Person;
    procedure set_Item(index: Integer; Value: Person);
    property Count: Integer read get_Count;
    property Item[index: Integer]: Person read get_Item write set_Item; default;
    procedure Clear;
    procedure RemoveAt(index: Integer);
    function Add(value: Person): Integer;
    function Contains(value: Person): Boolean;
    function IndexOf(value: Person): Integer;
    procedure Insert(index: Integer; value: Person);
    procedure Remove(value: Person);
  end;
  [UmlElement]
  Person = class(System.Object, ILoopBack)
  strict protected
    [EcoAutoGenerated]
    _content: IContent;
  protected
  const
    PersonFirstMember = 0;
  const
    PersonMemberCount = (Person.PersonFirstMember + 0);
  strict private
    {$REGION 'Autogenerated ECO code'}
  public
    [EcoAutoGenerated]
    function AsIObject: IObject;
    [EcoAutoGenerated]
    constructor Create(content: IContent); overload;
    [EcoAutoGenerated]
    function get_MemberByIndex(index: Integer): System.Object; virtual;
    [EcoAutoGenerated]
    procedure set_MemberByIndex(index: Integer; value: System.Object); virtual;
  type
    [EcoAutoGenerated]
    PersonListAdapter = class(ObjectListAdapter, IPersonList)
    public
      constructor Create(source: IList);
      function Add(value: Person): Integer;
      function Contains(value: Person): Boolean;
      function IndexOf(value: Person): Integer;
      procedure Insert(index: Integer; value: Person);
      procedure Remove(value: Person);
      function get_Item(index: Integer): Person;
      procedure set_Item(index: Integer; value: Person);
    end;
  strict protected
    [EcoAutoGenerated]
    procedure Initialize(serviceProvider: IEcoServiceProvider);
    [EcoAutoGenerated]
    procedure Deinitialize(serviceProvider: IEcoServiceProvider);
  strict private
    {$ENDREGION}
  public
    [EcoAutoMaintained]
    constructor Create(serviceProvider: IEcoServiceProvider); overload;
  end;

implementation



function Person.AsIObject: IObject;
begin
  Result := Self._content.AsIObject;
end;

constructor Person.Create(content: IContent);
begin
  inherited Create;
  Self._content := content;
end;

function Person.get_MemberByIndex(index: Integer): System.Object;
begin
  raise System.IndexOutOfRangeException.Create();
end;

procedure Person.set_MemberByIndex(index: Integer; value: System.Object);
begin
  raise System.IndexOutOfRangeException.Create();
end;

procedure Person.Initialize(serviceProvider: IEcoServiceProvider);
var
  factory: IInternalObjectContentFactory;
begin
  if (Self._content = nil) then
  begin
    factory := (IInternalObjectContentFactory(serviceProvider.GetEcoService(TypeOf(IInternalObjectContentFactory))));
    Self._content := factory.CreateContent(Self);
  end;
end;

procedure Person.Deinitialize(serviceProvider: IEcoServiceProvider);
var
  factory: IInternalObjectContentFactory;
begin
  if (Self._content <> nil) then
  begin
    factory := (IInternalObjectContentFactory(serviceProvider.GetEcoService(TypeOf(IInternalObjectContentFactory))));
    factory.CreateContentFailed(Self._content, Self);
    Self._content := nil;
  end;
end;
{$ENDREGION}

constructor Person.Create(serviceProvider: IEcoServiceProvider);
begin
  inherited Create;
  Self.Initialize(serviceProvider);
  try
    // If you add user code here, please remove the [EcoAutoMaintained] attribute
    // from the declaration in the interface section
  except
    on System.Exception do
    begin
      Self.Deinitialize(serviceProvider);
      raise;
    end;
  end;
end;



constructor Person.PersonListAdapter.Create(source: IList);
begin
  inherited Create(source);
end;

function Person.PersonListAdapter.Add(value: Person): Integer;
begin
  Result := Self.Adaptee.Add(value);
end;

function Person.PersonListAdapter.Contains(value: Person): Boolean;
begin
  Result := Self.Adaptee.Contains(value);
end;

function Person.PersonListAdapter.IndexOf(value: Person): Integer;
begin
  Result := Self.Adaptee.IndexOf(value);
end;

procedure Person.PersonListAdapter.Insert(index: Integer; value: Person);
begin
  Self.Adaptee.Insert(index, value);
end;

procedure Person.PersonListAdapter.Remove(value: Person);
begin
  Self.Adaptee.Remove(value);
end;

function Person.PersonListAdapter.get_Item(index: Integer): Person;
begin
  Result := Person(Adaptee[index]);
end;

procedure Person.PersonListAdapter.set_Item(index: Integer; value: Person);
begin
  Adaptee[index] := value;
end;







end.
