unit CoreClassesUnit;

interface

uses
  System.ComponentModel,
  System.Collections,
  Borland.Eco.Services,
  Borland.Eco.ObjectRepresentation,
  Borland.Eco.ObjectImplementation,
  Borland.Eco.UmlRt,
  Borland.Eco.UmlCodeAttributes;

type
  Person = class;
  Appointment = class;
  [UmlElement('Package')]
  [EcoCodeGenVersion('1.0')]
  [UmlMetaAttribute('ownedElement', TypeOf(Person))]
  [UmlMetaAttribute('ownedElement', TypeOf(Appointment))]
  CoreClasses = class
  public
  type
    [UmlElement('Association')]
    Association_1 = class
    end;
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(CoreClasses))]
  [UmlCollection(TypeOf(Person))]
  [EcoAutoGenerated]
  IPersonList = interface
    function get_Count: Integer;
    function get_Item(index: Integer): Person;
    procedure set_Item(index: Integer; Value: Person);
    property Count: Integer read get_Count;
    property Item[index: Integer]: Person read get_Item write set_Item; default;
    procedure Clear;
    procedure RemoveAt(index: Integer);
    function Add(value: Person): Integer;
    function Contains(value: Person): Boolean;
    function IndexOf(value: Person): Integer;
    procedure Insert(index: Integer; value: Person);
    procedure Remove(value: Person);
  end;
  IAppointmentList = interface;
  [UmlElement]
  Person = class(System.Object, ILoopBack)
  strict protected
    [EcoAutoGenerated]
    _content: IContent;
    function get__Fullname: string;
    procedure set__Fullname(Value: string);
    [EcoAutoGenerated]
    property _Fullname: string read get__Fullname write set__Fullname;
    function get__Appointments: IList;
    [EcoAutoGenerated]
    property _Appointments: IList read get__Appointments;
  protected
  const
    PersonFirstMember = 0;
  const
    PersonMemberCount = (Person.PersonFirstMember + 2);
  strict private
    {$REGION 'Autogenerated ECO code'}
  public
    [EcoAutoGenerated]
    function AsIObject: IObject;
    [EcoAutoGenerated]
    constructor Create(content: IContent); overload;
    [EcoAutoGenerated]
    function get_MemberByIndex(index: Integer): System.Object; virtual;
    [EcoAutoGenerated]
    procedure set_MemberByIndex(index: Integer; value: System.Object); virtual;
  type
    [EcoAutoGenerated]
    PersonListAdapter = class(ObjectListAdapter, IPersonList)
    public
      constructor Create(source: IList);
      function Add(value: Person): Integer;
      function Contains(value: Person): Boolean;
      function IndexOf(value: Person): Integer;
      procedure Insert(index: Integer; value: Person);
      procedure Remove(value: Person);
      function get_Item(index: Integer): Person;
      procedure set_Item(index: Integer; value: Person);
    end;
    function get_Fullname: string;
    procedure set_Fullname(Value: string);
    [UmlElement(Index=(Person.PersonFirstMember + 0))]
    [EcoAutoMaintained]
    [UmlTaggedValue('derived', 'False')]
    property Fullname: string read get_Fullname write set_Fullname;
    [UmlElement]
    procedure Operation_1;
    function get_Appointments: IAppointmentList;
    [UmlElement('AssociationEnd', Index=(Person.PersonFirstMember + 1))]
    [EcoAutoMaintained]
    [UmlMetaAttribute('association', TypeOf(CoreClassesUnit.CoreClasses.Association_1), Index=0)]
    [UmlMetaAttribute('multiplicity', '0..*')]
    property Appointments: IAppointmentList read get_Appointments;
  strict protected
    [EcoAutoGenerated]
    procedure Initialize(serviceProvider: IEcoServiceProvider);
    [EcoAutoGenerated]
    procedure Deinitialize(serviceProvider: IEcoServiceProvider);
  strict private
    {$ENDREGION}
  public
    [EcoAutoMaintained]
    constructor Create(serviceProvider: IEcoServiceProvider); overload;
  end;
  [UmlCollection(TypeOf(Appointment))]
  [EcoAutoGenerated]
  IAppointmentList = interface
    function get_Count: Integer;
    function get_Item(index: Integer): Appointment;
    procedure set_Item(index: Integer; Value: Appointment);
    property Count: Integer read get_Count;
    property Item[index: Integer]: Appointment read get_Item write set_Item; default;
    procedure Clear;
    procedure RemoveAt(index: Integer);
    function Add(value: Appointment): Integer;
    function Contains(value: Appointment): Boolean;
    function IndexOf(value: Appointment): Integer;
    procedure Insert(index: Integer; value: Appointment);
    procedure Remove(value: Appointment);
  end;
  [UmlElement]
  Appointment = class(System.Object, ILoopBack)
  strict protected
    [EcoAutoGenerated]
    _content: IContent;
    function get__Owner: Person;
    procedure set__Owner(Value: Person);
    [EcoAutoGenerated]
    property _Owner: Person read get__Owner write set__Owner;
  protected
  const
    AppointmentFirstMember = 0;
  const
    AppointmentMemberCount = (Appointment.AppointmentFirstMember + 1);
  strict private
    {$REGION 'Autogenerated ECO code'}
  public
    [EcoAutoGenerated]
    function AsIObject: IObject;
    [EcoAutoGenerated]
    constructor Create(content: IContent); overload;
    [EcoAutoGenerated]
    function get_MemberByIndex(index: Integer): System.Object; virtual;
    [EcoAutoGenerated]
    procedure set_MemberByIndex(index: Integer; value: System.Object); virtual;
  type
    [EcoAutoGenerated]
    AppointmentListAdapter = class(ObjectListAdapter, IAppointmentList)
    public
      constructor Create(source: IList);
      function Add(value: Appointment): Integer;
      function Contains(value: Appointment): Boolean;
      function IndexOf(value: Appointment): Integer;
      procedure Insert(index: Integer; value: Appointment);
      procedure Remove(value: Appointment);
      function get_Item(index: Integer): Appointment;
      procedure set_Item(index: Integer; value: Appointment);
    end;
    function get_Owner: Person;
    procedure set_Owner(Value: Person);
    [UmlElement('AssociationEnd', Index=(Appointment.AppointmentFirstMember + 0))]
    [EcoAutoMaintained]
    [UmlMetaAttribute('association', TypeOf(CoreClassesUnit.CoreClasses.Association_1), Index=1)]
    [UmlMetaAttribute('multiplicity', '1')]
    property Owner: Person read get_Owner write set_Owner;
  strict protected
    [EcoAutoGenerated]
    procedure Initialize(serviceProvider: IEcoServiceProvider);
    [EcoAutoGenerated]
    procedure Deinitialize(serviceProvider: IEcoServiceProvider);
  strict private
    {$ENDREGION}
  public
    [EcoAutoMaintained]
    constructor Create(serviceProvider: IEcoServiceProvider); overload;
  end;

implementation



function Person.AsIObject: IObject;
begin
  Result := Self._content.AsIObject;
end;

constructor Person.Create(content: IContent);
begin
  inherited Create;
  Self._content := content;
end;

function Person.get_MemberByIndex(index: Integer): System.Object;
begin
  case index of
    PersonFirstMember + 0:
        result := System.Object(self.Fullname);
    PersonFirstMember + 1:
        result := self.Appointments;
    else
      raise System.IndexOutOfRangeException.Create();
  end;
end;

procedure Person.set_MemberByIndex(index: Integer; value: System.Object);
begin
  case index of
    PersonFirstMember + 0:
      self.Fullname := string(value);
    else
      raise System.IndexOutOfRangeException.Create();
  end;
end;

procedure Person.Initialize(serviceProvider: IEcoServiceProvider);
var
  factory: IInternalObjectContentFactory;
begin
  if (Self._content = nil) then
  begin
    factory := (IInternalObjectContentFactory(serviceProvider.GetEcoService(TypeOf(IInternalObjectContentFactory))));
    Self._content := factory.CreateContent(Self);
  end;
end;

procedure Person.Deinitialize(serviceProvider: IEcoServiceProvider);
var
  factory: IInternalObjectContentFactory;
begin
  if (Self._content <> nil) then
  begin
    factory := (IInternalObjectContentFactory(serviceProvider.GetEcoService(TypeOf(IInternalObjectContentFactory))));
    factory.CreateContentFailed(Self._content, Self);
    Self._content := nil;
  end;
end;
{$ENDREGION}

constructor Person.Create(serviceProvider: IEcoServiceProvider);
begin
  inherited Create;
  Self.Initialize(serviceProvider);
  try
    // If you add user code here, please remove the [EcoAutoMaintained] attribute
    // from the declaration in the interface section
  except
    on System.Exception do
    begin
      Self.Deinitialize(serviceProvider);
      raise;
    end;
  end;
end;

function Person.get__Appointments: IList;
begin
  Result := (IList(Self._content.get_MemberByIndex((PersonFirstMember + 1))));
end;

function Person.get_Appointments: IAppointmentList;
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Result := CoreClassesUnit.Appointment.AppointmentListAdapter.Create(Self._Appointments);
end;

procedure Person.Operation_1;
begin
end;

function Person.get__Fullname: string;
begin
  Result := (string(Self._content.get_MemberByIndex((PersonFirstMember + 0))));
end;

procedure Person.set__Fullname(Value: string);
begin
  Self._content.set_MemberByIndex((PersonFirstMember + 0), (System.Object(Value)));
end;

function Person.get_Fullname: string;
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Result := Self._Fullname;
end;

procedure Person.set_Fullname(Value: string);
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Self._Fullname := Value;
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
end;



constructor Person.PersonListAdapter.Create(source: IList);
begin
  inherited Create(source);
end;

function Person.PersonListAdapter.Add(value: Person): Integer;
begin
  Result := Self.Adaptee.Add(value);
end;

function Person.PersonListAdapter.Contains(value: Person): Boolean;
begin
  Result := Self.Adaptee.Contains(value);
end;

function Person.PersonListAdapter.IndexOf(value: Person): Integer;
begin
  Result := Self.Adaptee.IndexOf(value);
end;

procedure Person.PersonListAdapter.Insert(index: Integer; value: Person);
begin
  Self.Adaptee.Insert(index, value);
end;

procedure Person.PersonListAdapter.Remove(value: Person);
begin
  Self.Adaptee.Remove(value);
end;

function Person.PersonListAdapter.get_Item(index: Integer): Person;
begin
  Result := Person(Adaptee[index]);
end;

procedure Person.PersonListAdapter.set_Item(index: Integer; value: Person);
begin
  Adaptee[index] := value;
end;



function Appointment.AsIObject: IObject;
begin
  Result := Self._content.AsIObject;
end;

constructor Appointment.Create(content: IContent);
begin
  inherited Create;
  Self._content := content;
end;

function Appointment.get_MemberByIndex(index: Integer): System.Object;
begin
  case index of
    AppointmentFirstMember + 0:
        result := self.Owner;
    else
      raise System.IndexOutOfRangeException.Create();
  end;
end;

procedure Appointment.set_MemberByIndex(index: Integer; value: System.Object);
begin
  case index of
    AppointmentFirstMember + 0:
      self.Owner := CoreClassesUnit.Person(value);
    else
      raise System.IndexOutOfRangeException.Create();
  end;
end;

procedure Appointment.Initialize(serviceProvider: IEcoServiceProvider);
var
  factory: IInternalObjectContentFactory;
begin
  if (Self._content = nil) then
  begin
    factory := (IInternalObjectContentFactory(serviceProvider.GetEcoService(TypeOf(IInternalObjectContentFactory))));
    Self._content := factory.CreateContent(Self);
  end;
end;

procedure Appointment.Deinitialize(serviceProvider: IEcoServiceProvider);
var
  factory: IInternalObjectContentFactory;
begin
  if (Self._content <> nil) then
  begin
    factory := (IInternalObjectContentFactory(serviceProvider.GetEcoService(TypeOf(IInternalObjectContentFactory))));
    factory.CreateContentFailed(Self._content, Self);
    Self._content := nil;
  end;
end;
{$ENDREGION}

constructor Appointment.Create(serviceProvider: IEcoServiceProvider);
begin
  inherited Create;
  Self.Initialize(serviceProvider);
  try
    // If you add user code here, please remove the [EcoAutoMaintained] attribute
    // from the declaration in the interface section
  except
    on System.Exception do
    begin
      Self.Deinitialize(serviceProvider);
      raise;
    end;
  end;
end;

function Appointment.get__Owner: Person;
begin
  Result := (CoreClassesUnit.Person(Self._content.get_MemberByIndex((AppointmentFirstMember 
      + 0))));
end;

procedure Appointment.set__Owner(Value: Person);
begin
  Self._content.set_MemberByIndex((AppointmentFirstMember + 0), (System.Object(Value)));
end;

function Appointment.get_Owner: Person;
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Result := Self._Owner;
end;

procedure Appointment.set_Owner(Value: Person);
begin
  Self._Owner := Value;
end;



constructor Appointment.AppointmentListAdapter.Create(source: IList);
begin
  inherited Create(source);
end;

function Appointment.AppointmentListAdapter.Add(value: Appointment): Integer;
begin
  Result := Self.Adaptee.Add(value);
end;

function Appointment.AppointmentListAdapter.Contains(value: Appointment): Boolean;
begin
  Result := Self.Adaptee.Contains(value);
end;

function Appointment.AppointmentListAdapter.IndexOf(value: Appointment): Integer;
begin
  Result := Self.Adaptee.IndexOf(value);
end;

procedure Appointment.AppointmentListAdapter.Insert(index: Integer; value: Appointment);
begin
  Self.Adaptee.Insert(index, value);
end;

procedure Appointment.AppointmentListAdapter.Remove(value: Appointment);
begin
  Self.Adaptee.Remove(value);
end;

function Appointment.AppointmentListAdapter.get_Item(index: Integer): Appointment;
begin
  Result := Appointment(Adaptee[index]);
end;

procedure Appointment.AppointmentListAdapter.set_Item(index: Integer; value: Appointment);
begin
  Adaptee[index] := value;
end;

{ CoreClasses }
















end.
