unit CoreClassesUnit;

interface

uses
  System.ComponentModel,
  System.Collections,
  Borland.Eco.Services,
  Borland.Eco.ObjectRepresentation,
  Borland.Eco.ObjectImplementation,
  Borland.Eco.UmlRt,
  Borland.Eco.UmlCodeAttributes,
  Borland.Eco.Subscription;

type
  Person = class;
  Appointment = class;
  Order = class;
  OrderItem = class;
  [UmlElement('Package')]
  [EcoCodeGenVersion('1.0')]
  [UmlMetaAttribute('ownedElement', TypeOf(Person))]
  [UmlMetaAttribute('ownedElement', TypeOf(Appointment))]
  [UmlMetaAttribute('ownedElement', TypeOf(Order))]
  [UmlMetaAttribute('ownedElement', TypeOf(OrderItem))]
  CoreClasses = class
  public
  type
    [UmlElement('Association')]
    Association_1 = class
    end;
  type
    [UmlElement('Association')]
    [UmlTaggedValue('derived', 'False')]
    OrderContents = class
    end;
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(CoreClasses))]
  [UmlCollection(TypeOf(Person))]
  [EcoAutoGenerated]
  IPersonList = interface
    function get_Count: Integer;
    function get_Item(index: Integer): Person;
    procedure set_Item(index: Integer; Value: Person);
    property Count: Integer read get_Count;
    property Item[index: Integer]: Person read get_Item write set_Item; default;
    procedure Clear;
    procedure RemoveAt(index: Integer);
    function Add(value: Person): Integer;
    function Contains(value: Person): Boolean;
    function IndexOf(value: Person): Integer;
    procedure Insert(index: Integer; value: Person);
    procedure Remove(value: Person);
  end;
  IAppointmentList = interface;
  [UmlElement]
  Person = class(System.Object, ILoopBack)
  strict protected
    [EcoAutoGenerated]
    _content: IContent;
    function get__Fullname: string;
    procedure set__Fullname(Value: string);
    [EcoAutoGenerated]
    property _Fullname: string read get__Fullname write set__Fullname;
    function get__Appointments: IList;
    [EcoAutoGenerated]
    property _Appointments: IList read get__Appointments;
  protected
  const
    PersonFirstMember = 0;
  const
    PersonMemberCount = (Person.PersonFirstMember + 2);
  strict private
    {$REGION 'Autogenerated ECO code'}
  public
    [EcoAutoGenerated]
    function AsIObject: IObject;
    [EcoAutoGenerated]
    constructor Create(content: IContent); overload;
    [EcoAutoGenerated]
    function get_MemberByIndex(index: Integer): System.Object; virtual;
    [EcoAutoGenerated]
    procedure set_MemberByIndex(index: Integer; value: System.Object); virtual;
  type
    [EcoAutoGenerated]
    PersonListAdapter = class(ObjectListAdapter, IPersonList)
    public
      constructor Create(source: IList);
      function Add(value: Person): Integer;
      function Contains(value: Person): Boolean;
      function IndexOf(value: Person): Integer;
      procedure Insert(index: Integer; value: Person);
      procedure Remove(value: Person);
      function get_Item(index: Integer): Person;
      procedure set_Item(index: Integer; value: Person);
    end;
    function get_Fullname: string;
    procedure set_Fullname(Value: string);
    [UmlElement(Index=(Person.PersonFirstMember + 0))]
    [EcoAutoMaintained]
    [UmlTaggedValue('derived', 'False')]
    property Fullname: string read get_Fullname write set_Fullname;
    [UmlElement]
    procedure Operation_1;
    function get_Appointments: IAppointmentList;
    [UmlElement('AssociationEnd', Index=(Person.PersonFirstMember + 1))]
    [EcoAutoMaintained]
    [UmlMetaAttribute('association', TypeOf(CoreClassesUnit.CoreClasses.Association_1), Index=0)]
    [UmlMetaAttribute('multiplicity', '0..*')]
    property Appointments: IAppointmentList read get_Appointments;
  strict protected
    [EcoAutoGenerated]
    procedure Initialize(serviceProvider: IEcoServiceProvider);
    [EcoAutoGenerated]
    procedure Deinitialize(serviceProvider: IEcoServiceProvider);
  strict private
    {$ENDREGION}
  public
    [EcoAutoMaintained]
    constructor Create(serviceProvider: IEcoServiceProvider); overload;
  end;
  [UmlCollection(TypeOf(Appointment))]
  [EcoAutoGenerated]
  IAppointmentList = interface
    function get_Count: Integer;
    function get_Item(index: Integer): Appointment;
    procedure set_Item(index: Integer; Value: Appointment);
    property Count: Integer read get_Count;
    property Item[index: Integer]: Appointment read get_Item write set_Item; default;
    procedure Clear;
    procedure RemoveAt(index: Integer);
    function Add(value: Appointment): Integer;
    function Contains(value: Appointment): Boolean;
    function IndexOf(value: Appointment): Integer;
    procedure Insert(index: Integer; value: Appointment);
    procedure Remove(value: Appointment);
  end;
  [UmlElement]
  Appointment = class(System.Object, ILoopBack)
  strict protected
    [EcoAutoGenerated]
    _content: IContent;
    function get__Owner: Person;
    procedure set__Owner(Value: Person);
    [EcoAutoGenerated]
    property _Owner: Person read get__Owner write set__Owner;
    function get__Start: DateTime;
    procedure set__Start(Value: DateTime);
    [EcoAutoGenerated]
    property _Start: DateTime read get__Start write set__Start;
    function get__Duration: Integer;
    procedure set__Duration(Value: Integer);
    [EcoAutoGenerated]
    property _Duration: Integer read get__Duration write set__Duration;
    function get__Finish: DateTime;
    procedure set__Finish(Value: DateTime);
    [EcoAutoGenerated]
    property _Finish: DateTime read get__Finish write set__Finish;
  protected
  const
    AppointmentFirstMember = 0;
  const
    AppointmentMemberCount = (Appointment.AppointmentFirstMember + 4);
  strict private
    {$REGION 'Autogenerated ECO code'}
  public
    [EcoAutoGenerated]
    function AsIObject: IObject;
    [EcoAutoGenerated]
    constructor Create(content: IContent); overload;
    [EcoAutoGenerated]
    function get_MemberByIndex(index: Integer): System.Object; virtual;
    [EcoAutoGenerated]
    procedure set_MemberByIndex(index: Integer; value: System.Object); virtual;
  type
    [EcoAutoGenerated]
    AppointmentListAdapter = class(ObjectListAdapter, IAppointmentList)
    public
      constructor Create(source: IList);
      function Add(value: Appointment): Integer;
      function Contains(value: Appointment): Boolean;
      function IndexOf(value: Appointment): Integer;
      procedure Insert(index: Integer; value: Appointment);
      procedure Remove(value: Appointment);
      function get_Item(index: Integer): Appointment;
      procedure set_Item(index: Integer; value: Appointment);
    end;
    function get_Owner: Person;
    procedure set_Owner(Value: Person);
    [UmlElement('AssociationEnd', Index=(Appointment.AppointmentFirstMember + 3))]
    [EcoAutoMaintained]
    [UmlMetaAttribute('association', TypeOf(CoreClassesUnit.CoreClasses.Association_1), Index=1)]
    [UmlMetaAttribute('multiplicity', '1')]
    property Owner: Person read get_Owner write set_Owner;
    function get_Start: DateTime;
    procedure set_Start(Value: DateTime);
    [UmlElement(Index=(Appointment.AppointmentFirstMember + 0))]
    [EcoAutoMaintained]
    [UmlTaggedValue('derived', 'False')]
    property Start: DateTime read get_Start write set_Start;
    function get_Duration: Integer;
    procedure set_Duration(Value: Integer);
    [UmlElement(Index=(Appointment.AppointmentFirstMember + 1))]
    [EcoAutoMaintained]
    [UmlTaggedValue('derived', 'False')]
    property Duration: Integer read get_Duration write set_Duration;
    function get_Finish: DateTime;
    function FinishDeriveAndSubscribe(ReevaluateSubscriber,
    ResubscribeSubscriber: ISubscriber): System.Object;
    procedure set_Finish(Value: DateTime);
    [UmlElement(Index=(Appointment.AppointmentFirstMember + 2))]
    [UmlTaggedValue('derived', 'True')]
    [UmlTaggedValue('persistence', 'transient')]
    property Finish: DateTime read get_Finish write set_Finish;
  strict protected
    [EcoAutoGenerated]
    procedure Initialize(serviceProvider: IEcoServiceProvider);
    [EcoAutoGenerated]
    procedure Deinitialize(serviceProvider: IEcoServiceProvider);
  strict private
    {$ENDREGION}
  public
    [EcoAutoMaintained]
    constructor Create(serviceProvider: IEcoServiceProvider); overload;
  end;
  [UmlCollection(TypeOf(Order))]
  [EcoAutoGenerated]
  IOrderList = interface
    function get_Count: Integer;
    function get_Item(index: Integer): Order;
    procedure set_Item(index: Integer; Value: Order);
    property Count: Integer read get_Count;
    property Item[index: Integer]: Order read get_Item write set_Item; default;
    procedure Clear;
    procedure RemoveAt(index: Integer);
    function Add(value: Order): Integer;
    function Contains(value: Order): Boolean;
    function IndexOf(value: Order): Integer;
    procedure Insert(index: Integer; value: Order);
    procedure Remove(value: Order);
  end;
  IOrderItemList = interface;
  [UmlElement]
  Order = class(System.Object, ILoopBack)
  strict protected
    [EcoAutoGenerated]
    _content: IContent;
    function get__Items: IList;
    [EcoAutoGenerated]
    property _Items: IList read get__Items;
    function get__ShippingQuantity: Integer;
    [EcoAutoGenerated]
    property _ShippingQuantity: Integer read get__ShippingQuantity;
  protected
  const
    OrderFirstMember = 0;
  const
    OrderMemberCount = (Order.OrderFirstMember + 2);
  strict private
    {$REGION 'Autogenerated ECO code'}
  public
    [EcoAutoGenerated]
    function AsIObject: IObject;
    [EcoAutoGenerated]
    constructor Create(content: IContent); overload;
    [EcoAutoGenerated]
    function get_MemberByIndex(index: Integer): System.Object; virtual;
    [EcoAutoGenerated]
    procedure set_MemberByIndex(index: Integer; value: System.Object); virtual;
  type
    [EcoAutoGenerated]
    OrderListAdapter = class(ObjectListAdapter, IOrderList)
    public
      constructor Create(source: IList);
      function Add(value: Order): Integer;
      function Contains(value: Order): Boolean;
      function IndexOf(value: Order): Integer;
      procedure Insert(index: Integer; value: Order);
      procedure Remove(value: Order);
      function get_Item(index: Integer): Order;
      procedure set_Item(index: Integer; value: Order);
    end;
    function get_Items: IOrderItemList;
    [UmlElement('AssociationEnd', Index=(Order.OrderFirstMember + 1))]
    [EcoAutoMaintained]
    [UmlMetaAttribute('association', TypeOf(CoreClassesUnit.CoreClasses.OrderContents), Index=0)]
    [UmlMetaAttribute('multiplicity', '0..*')]
    property Items: IOrderItemList read get_Items;
    function get_ShippingQuantity: Integer;
    [UmlElement(Index=(Order.OrderFirstMember + 0))]
    [EcoAutoMaintained]
    [UmlTaggedValue('derived', 'True')]
    [UmlTaggedValue('persistence', 'transient')]
    [UmlTaggedValue('Eco.DerivationOCL', 'Items.Quantity->sum')]
    property ShippingQuantity: Integer read get_ShippingQuantity;
  strict protected
    [EcoAutoGenerated]
    procedure Initialize(serviceProvider: IEcoServiceProvider);
    [EcoAutoGenerated]
    procedure Deinitialize(serviceProvider: IEcoServiceProvider);
  strict private
    {$ENDREGION}
  public
    [EcoAutoMaintained]
    constructor Create(serviceProvider: IEcoServiceProvider); overload;
  end;
  [UmlCollection(TypeOf(OrderItem))]
  [EcoAutoGenerated]
  IOrderItemList = interface
    function get_Count: Integer;
    function get_Item(index: Integer): OrderItem;
    procedure set_Item(index: Integer; Value: OrderItem);
    property Count: Integer read get_Count;
    property Item[index: Integer]: OrderItem read get_Item write set_Item; default;
    procedure Clear;
    procedure RemoveAt(index: Integer);
    function Add(value: OrderItem): Integer;
    function Contains(value: OrderItem): Boolean;
    function IndexOf(value: OrderItem): Integer;
    procedure Insert(index: Integer; value: OrderItem);
    procedure Remove(value: OrderItem);
  end;
  [UmlElement]
  OrderItem = class(System.Object, ILoopBack)
  strict protected
    [EcoAutoGenerated]
    _content: IContent;
    function get__OwningOrder: Order;
    procedure set__OwningOrder(Value: Order);
    [EcoAutoGenerated]
    property _OwningOrder: Order read get__OwningOrder write set__OwningOrder;
    function get__Quantity: Integer;
    procedure set__Quantity(Value: Integer);
    [EcoAutoGenerated]
    property _Quantity: Integer read get__Quantity write set__Quantity;
    function get__UnitPrice: System.Double;
    procedure set__UnitPrice(Value: System.Double);
    [EcoAutoGenerated]
    property _UnitPrice: System.Double read get__UnitPrice write set__UnitPrice;
    function get__TotalPrice: System.Double;
    [EcoAutoGenerated]
    property _TotalPrice: System.Double read get__TotalPrice;
  protected
  const
    OrderItemFirstMember = 0;
  const
    OrderItemMemberCount = (OrderItem.OrderItemFirstMember + 4);
  strict private
    {$REGION 'Autogenerated ECO code'}
  public
    [EcoAutoGenerated]
    function AsIObject: IObject;
    [EcoAutoGenerated]
    constructor Create(content: IContent); overload;
    [EcoAutoGenerated]
    function get_MemberByIndex(index: Integer): System.Object; virtual;
    [EcoAutoGenerated]
    procedure set_MemberByIndex(index: Integer; value: System.Object); virtual;
  type
    [EcoAutoGenerated]
    OrderItemListAdapter = class(ObjectListAdapter, IOrderItemList)
    public
      constructor Create(source: IList);
      function Add(value: OrderItem): Integer;
      function Contains(value: OrderItem): Boolean;
      function IndexOf(value: OrderItem): Integer;
      procedure Insert(index: Integer; value: OrderItem);
      procedure Remove(value: OrderItem);
      function get_Item(index: Integer): OrderItem;
      procedure set_Item(index: Integer; value: OrderItem);
    end;
    function get_OwningOrder: Order;
    procedure set_OwningOrder(Value: Order);
    [UmlElement('AssociationEnd', Index=(OrderItem.OrderItemFirstMember + 3))]
    [EcoAutoMaintained]
    [UmlMetaAttribute('association', TypeOf(CoreClassesUnit.CoreClasses.OrderContents), Index=1)]
    [UmlMetaAttribute('multiplicity', '1')]
    property OwningOrder: Order read get_OwningOrder write set_OwningOrder;
    function get_Quantity: Integer;
    procedure set_Quantity(Value: Integer);
    [UmlElement(Index=(OrderItem.OrderItemFirstMember + 0))]
    [EcoAutoMaintained]
    [UmlTaggedValue('derived', 'False')]
    property Quantity: Integer read get_Quantity write set_Quantity;
    function get_UnitPrice: System.Double;
    procedure set_UnitPrice(Value: System.Double);
    [UmlElement(Index=(OrderItem.OrderItemFirstMember + 1))]
    [EcoAutoMaintained]
    [UmlTaggedValue('derived', 'False')]
    property UnitPrice: System.Double read get_UnitPrice write set_UnitPrice;
    function get_TotalPrice: System.Double;
    [UmlElement(Index=(OrderItem.OrderItemFirstMember + 2))]
    [EcoAutoMaintained]
    [UmlTaggedValue('derived', 'True')]
    [UmlTaggedValue('persistence', 'transient')]
    [UmlTaggedValue('Eco.DerivationOCL', 'Quantity * UnitPrice')]
    property TotalPrice: System.Double read get_TotalPrice;
  strict protected
    [EcoAutoGenerated]
    procedure Initialize(serviceProvider: IEcoServiceProvider);
    [EcoAutoGenerated]
    procedure Deinitialize(serviceProvider: IEcoServiceProvider);
  strict private
    {$ENDREGION}
  public
    [EcoAutoMaintained]
    constructor Create(serviceProvider: IEcoServiceProvider); overload;
  end;

implementation



function Person.AsIObject: IObject;
begin
  Result := Self._content.AsIObject;
end;

constructor Person.Create(content: IContent);
begin
  inherited Create;
  Self._content := content;
end;

function Person.get_MemberByIndex(index: Integer): System.Object;
begin
  case index of
    PersonFirstMember + 0:
        result := System.Object(self.Fullname);
    PersonFirstMember + 1:
        result := self.Appointments;
    else
      raise System.IndexOutOfRangeException.Create();
  end;
end;

procedure Person.set_MemberByIndex(index: Integer; value: System.Object);
begin
  case index of
    PersonFirstMember + 0:
      self.Fullname := string(value);
    else
      raise System.IndexOutOfRangeException.Create();
  end;
end;

procedure Person.Initialize(serviceProvider: IEcoServiceProvider);
var
  factory: IInternalObjectContentFactory;
begin
  if (Self._content = nil) then
  begin
    factory := (IInternalObjectContentFactory(serviceProvider.GetEcoService(TypeOf(IInternalObjectContentFactory))));
    Self._content := factory.CreateContent(Self);
  end;
end;

procedure Person.Deinitialize(serviceProvider: IEcoServiceProvider);
var
  factory: IInternalObjectContentFactory;
begin
  if (Self._content <> nil) then
  begin
    factory := (IInternalObjectContentFactory(serviceProvider.GetEcoService(TypeOf(IInternalObjectContentFactory))));
    factory.CreateContentFailed(Self._content, Self);
    Self._content := nil;
  end;
end;
{$ENDREGION}

constructor Person.Create(serviceProvider: IEcoServiceProvider);
begin
  inherited Create;
  Self.Initialize(serviceProvider);
  try
    // If you add user code here, please remove the [EcoAutoMaintained] attribute
    // from the declaration in the interface section
  except
    on System.Exception do
    begin
      Self.Deinitialize(serviceProvider);
      raise;
    end;
  end;
end;

function Person.get__Appointments: IList;
begin
  Result := (IList(Self._content.get_MemberByIndex((PersonFirstMember + 1))));
end;

function Person.get_Appointments: IAppointmentList;
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Result := CoreClassesUnit.Appointment.AppointmentListAdapter.Create(Self._Appointments);
end;

procedure Person.Operation_1;
begin
end;

function Person.get__Fullname: string;
begin
  Result := (string(Self._content.get_MemberByIndex((PersonFirstMember + 0))));
end;

procedure Person.set__Fullname(Value: string);
begin
  Self._content.set_MemberByIndex((PersonFirstMember + 0), (System.Object(Value)));
end;

function Person.get_Fullname: string;
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Result := Self._Fullname;
end;

procedure Person.set_Fullname(Value: string);
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Self._Fullname := Value;
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
end;



constructor Person.PersonListAdapter.Create(source: IList);
begin
  inherited Create(source);
end;

function Person.PersonListAdapter.Add(value: Person): Integer;
begin
  Result := Self.Adaptee.Add(value);
end;

function Person.PersonListAdapter.Contains(value: Person): Boolean;
begin
  Result := Self.Adaptee.Contains(value);
end;

function Person.PersonListAdapter.IndexOf(value: Person): Integer;
begin
  Result := Self.Adaptee.IndexOf(value);
end;

procedure Person.PersonListAdapter.Insert(index: Integer; value: Person);
begin
  Self.Adaptee.Insert(index, value);
end;

procedure Person.PersonListAdapter.Remove(value: Person);
begin
  Self.Adaptee.Remove(value);
end;

function Person.PersonListAdapter.get_Item(index: Integer): Person;
begin
  Result := Person(Adaptee[index]);
end;

procedure Person.PersonListAdapter.set_Item(index: Integer; value: Person);
begin
  Adaptee[index] := value;
end;



function Appointment.AsIObject: IObject;
begin
  Result := Self._content.AsIObject;
end;

constructor Appointment.Create(content: IContent);
begin
  inherited Create;
  Self._content := content;
end;

function Appointment.get_MemberByIndex(index: Integer): System.Object;
begin
  case index of
    AppointmentFirstMember + 0:
        result := System.Object(self.Start);
    AppointmentFirstMember + 1:
        result := System.Object(self.Duration);
    AppointmentFirstMember + 2:
        result := System.Object(self.Finish);
    AppointmentFirstMember + 3:
        result := self.Owner;
    else
      raise System.IndexOutOfRangeException.Create();
  end;
end;

procedure Appointment.set_MemberByIndex(index: Integer; value: System.Object);
begin
  case index of
    AppointmentFirstMember + 0:
      self.Start := DateTime(value);
    AppointmentFirstMember + 1:
      self.Duration := Integer(value);
    AppointmentFirstMember + 2:
      self.Finish := DateTime(value);
    AppointmentFirstMember + 3:
      self.Owner := CoreClassesUnit.Person(value);
    else
      raise System.IndexOutOfRangeException.Create();
  end;
end;

procedure Appointment.Initialize(serviceProvider: IEcoServiceProvider);
var
  factory: IInternalObjectContentFactory;
begin
  if (Self._content = nil) then
  begin
    factory := (IInternalObjectContentFactory(serviceProvider.GetEcoService(TypeOf(IInternalObjectContentFactory))));
    Self._content := factory.CreateContent(Self);
  end;
end;

procedure Appointment.Deinitialize(serviceProvider: IEcoServiceProvider);
var
  factory: IInternalObjectContentFactory;
begin
  if (Self._content <> nil) then
  begin
    factory := (IInternalObjectContentFactory(serviceProvider.GetEcoService(TypeOf(IInternalObjectContentFactory))));
    factory.CreateContentFailed(Self._content, Self);
    Self._content := nil;
  end;
end;
{$ENDREGION}

constructor Appointment.Create(serviceProvider: IEcoServiceProvider);
begin
  inherited Create;
  Self.Initialize(serviceProvider);
  try
    // If you add user code here, please remove the [EcoAutoMaintained] attribute
    // from the declaration in the interface section
  except
    on System.Exception do
    begin
      Self.Deinitialize(serviceProvider);
      raise;
    end;
  end;
end;

procedure Appointment.set__Finish(Value: DateTime);
begin
  Self._content.set_MemberByIndex((AppointmentFirstMember + 2), (System.Object(Value)));
end;

procedure Appointment.set_Finish(Value: DateTime);
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Duration := Convert.ToInt32(Value.Subtract(Start).TotalMinutes);
end;

function Appointment.get__Finish: DateTime;
begin
  Result := (DateTime(Self._content.get_MemberByIndex((AppointmentFirstMember 
      + 2))));
end;

function Appointment.get_Finish: DateTime;
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Result := Self._Finish;
end;

function Appointment.FinishDeriveAndSubscribe(
  reevaluateSubscriber, resubscribeSubscriber: 
  ISubscriber): system.object;
begin
  AsIObject.Properties['Start'].SubscribeToValue(reevaluateSubscriber);
  AsIObject.Properties['Duration'].SubscribeToValue(reevaluateSubscriber);
  Result := Start.AddMinutes(Duration);
end;

function Appointment.get__Duration: Integer;
begin
  Result := (Integer(Self._content.get_MemberByIndex((AppointmentFirstMember 
      + 1))));
end;

procedure Appointment.set__Duration(Value: Integer);
begin
  Self._content.set_MemberByIndex((AppointmentFirstMember + 1), (System.Object(Value)));
end;

function Appointment.get_Duration: Integer;
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Result := Self._Duration;
end;

procedure Appointment.set_Duration(Value: Integer);
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Self._Duration := Value;
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
end;

function Appointment.get__Start: DateTime;
begin
  Result := (DateTime(Self._content.get_MemberByIndex((AppointmentFirstMember 
      + 0))));
end;

procedure Appointment.set__Start(Value: DateTime);
begin
  Self._content.set_MemberByIndex((AppointmentFirstMember + 0), (System.Object(Value)));
end;

function Appointment.get_Start: DateTime;
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Result := Self._Start;
end;

procedure Appointment.set_Start(Value: DateTime);
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Self._Start := Value;
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
end;

function Appointment.get__Owner: Person;
begin
  Result := (CoreClassesUnit.Person(Self._content.get_MemberByIndex((AppointmentFirstMember 
      + 3))));
end;

procedure Appointment.set__Owner(Value: Person);
begin
  Self._content.set_MemberByIndex((AppointmentFirstMember + 3), (System.Object(Value)));
end;

function Appointment.get_Owner: Person;
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Result := Self._Owner;
end;

procedure Appointment.set_Owner(Value: Person);
begin
  Self._Owner := Value;
end;



constructor Appointment.AppointmentListAdapter.Create(source: IList);
begin
  inherited Create(source);
end;

function Appointment.AppointmentListAdapter.Add(value: Appointment): Integer;
begin
  Result := Self.Adaptee.Add(value);
end;

function Appointment.AppointmentListAdapter.Contains(value: Appointment): Boolean;
begin
  Result := Self.Adaptee.Contains(value);
end;

function Appointment.AppointmentListAdapter.IndexOf(value: Appointment): Integer;
begin
  Result := Self.Adaptee.IndexOf(value);
end;

procedure Appointment.AppointmentListAdapter.Insert(index: Integer; value: Appointment);
begin
  Self.Adaptee.Insert(index, value);
end;

procedure Appointment.AppointmentListAdapter.Remove(value: Appointment);
begin
  Self.Adaptee.Remove(value);
end;

function Appointment.AppointmentListAdapter.get_Item(index: Integer): Appointment;
begin
  Result := Appointment(Adaptee[index]);
end;

procedure Appointment.AppointmentListAdapter.set_Item(index: Integer; value: Appointment);
begin
  Adaptee[index] := value;
end;



function Order.AsIObject: IObject;
begin
  Result := Self._content.AsIObject;
end;

constructor Order.Create(content: IContent);
begin
  inherited Create;
  Self._content := content;
end;

function Order.get_MemberByIndex(index: Integer): System.Object;
begin
  case index of
    OrderFirstMember + 0:
        result := System.Object(self.ShippingQuantity);
    OrderFirstMember + 1:
        result := self.Items;
    else
      raise System.IndexOutOfRangeException.Create();
  end;
end;

procedure Order.set_MemberByIndex(index: Integer; value: System.Object);
begin
  raise System.IndexOutOfRangeException.Create();
end;

procedure Order.Initialize(serviceProvider: IEcoServiceProvider);
var
  factory: IInternalObjectContentFactory;
begin
  if (Self._content = nil) then
  begin
    factory := (IInternalObjectContentFactory(serviceProvider.GetEcoService(TypeOf(IInternalObjectContentFactory))));
    Self._content := factory.CreateContent(Self);
  end;
end;

procedure Order.Deinitialize(serviceProvider: IEcoServiceProvider);
var
  factory: IInternalObjectContentFactory;
begin
  if (Self._content <> nil) then
  begin
    factory := (IInternalObjectContentFactory(serviceProvider.GetEcoService(TypeOf(IInternalObjectContentFactory))));
    factory.CreateContentFailed(Self._content, Self);
    Self._content := nil;
  end;
end;
{$ENDREGION}

constructor Order.Create(serviceProvider: IEcoServiceProvider);
begin
  inherited Create;
  Self.Initialize(serviceProvider);
  try
    // If you add user code here, please remove the [EcoAutoMaintained] attribute
    // from the declaration in the interface section
  except
    on System.Exception do
    begin
      Self.Deinitialize(serviceProvider);
      raise;
    end;
  end;
end;

function Order.get__ShippingQuantity: Integer;
begin
  Result := (Integer(Self._content.get_MemberByIndex((OrderFirstMember + 0))));
end;

function Order.get_ShippingQuantity: Integer;
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Result := Self._ShippingQuantity;
end;

function Order.get__Items: IList;
begin
  Result := (IList(Self._content.get_MemberByIndex((OrderFirstMember + 1))));
end;

function Order.get_Items: IOrderItemList;
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Result := CoreClassesUnit.OrderItem.OrderItemListAdapter.Create(Self._Items);
end;



constructor Order.OrderListAdapter.Create(source: IList);
begin
  inherited Create(source);
end;

function Order.OrderListAdapter.Add(value: Order): Integer;
begin
  Result := Self.Adaptee.Add(value);
end;

function Order.OrderListAdapter.Contains(value: Order): Boolean;
begin
  Result := Self.Adaptee.Contains(value);
end;

function Order.OrderListAdapter.IndexOf(value: Order): Integer;
begin
  Result := Self.Adaptee.IndexOf(value);
end;

procedure Order.OrderListAdapter.Insert(index: Integer; value: Order);
begin
  Self.Adaptee.Insert(index, value);
end;

procedure Order.OrderListAdapter.Remove(value: Order);
begin
  Self.Adaptee.Remove(value);
end;

function Order.OrderListAdapter.get_Item(index: Integer): Order;
begin
  Result := Order(Adaptee[index]);
end;

procedure Order.OrderListAdapter.set_Item(index: Integer; value: Order);
begin
  Adaptee[index] := value;
end;



function OrderItem.AsIObject: IObject;
begin
  Result := Self._content.AsIObject;
end;

constructor OrderItem.Create(content: IContent);
begin
  inherited Create;
  Self._content := content;
end;

function OrderItem.get_MemberByIndex(index: Integer): System.Object;
begin
  case index of
    OrderItemFirstMember + 0:
        result := System.Object(self.Quantity);
    OrderItemFirstMember + 1:
        result := System.Object(self.UnitPrice);
    OrderItemFirstMember + 2:
        result := System.Object(self.TotalPrice);
    OrderItemFirstMember + 3:
        result := self.OwningOrder;
    else
      raise System.IndexOutOfRangeException.Create();
  end;
end;

procedure OrderItem.set_MemberByIndex(index: Integer; value: System.Object);
begin
  case index of
    OrderItemFirstMember + 0:
      self.Quantity := Integer(value);
    OrderItemFirstMember + 1:
      self.UnitPrice := Double(value);
    OrderItemFirstMember + 3:
      self.OwningOrder := CoreClassesUnit.Order(value);
    else
      raise System.IndexOutOfRangeException.Create();
  end;
end;

procedure OrderItem.Initialize(serviceProvider: IEcoServiceProvider);
var
  factory: IInternalObjectContentFactory;
begin
  if (Self._content = nil) then
  begin
    factory := (IInternalObjectContentFactory(serviceProvider.GetEcoService(TypeOf(IInternalObjectContentFactory))));
    Self._content := factory.CreateContent(Self);
  end;
end;

procedure OrderItem.Deinitialize(serviceProvider: IEcoServiceProvider);
var
  factory: IInternalObjectContentFactory;
begin
  if (Self._content <> nil) then
  begin
    factory := (IInternalObjectContentFactory(serviceProvider.GetEcoService(TypeOf(IInternalObjectContentFactory))));
    factory.CreateContentFailed(Self._content, Self);
    Self._content := nil;
  end;
end;
{$ENDREGION}

constructor OrderItem.Create(serviceProvider: IEcoServiceProvider);
begin
  inherited Create;
  Self.Initialize(serviceProvider);
  try
    // If you add user code here, please remove the [EcoAutoMaintained] attribute
    // from the declaration in the interface section
  except
    on System.Exception do
    begin
      Self.Deinitialize(serviceProvider);
      raise;
    end;
  end;
end;

function OrderItem.get__TotalPrice: System.Double;
begin
  Result := (System.Double(Self._content.get_MemberByIndex((OrderItemFirstMember 
      + 2))));
end;

function OrderItem.get_TotalPrice: System.Double;
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Result := Self._TotalPrice;
end;

function OrderItem.get__UnitPrice: System.Double;
begin
  Result := (System.Double(Self._content.get_MemberByIndex((OrderItemFirstMember 
      + 1))));
end;

procedure OrderItem.set__UnitPrice(Value: System.Double);
begin
  Self._content.set_MemberByIndex((OrderItemFirstMember + 1), (System.Object(Value)));
end;

function OrderItem.get_UnitPrice: System.Double;
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Result := Self._UnitPrice;
end;

procedure OrderItem.set_UnitPrice(Value: System.Double);
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Self._UnitPrice := Value;
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
end;

function OrderItem.get__Quantity: Integer;
begin
  Result := (Integer(Self._content.get_MemberByIndex((OrderItemFirstMember + 
      0))));
end;

procedure OrderItem.set__Quantity(Value: Integer);
begin
  Self._content.set_MemberByIndex((OrderItemFirstMember + 0), (System.Object(Value)));
end;

function OrderItem.get_Quantity: Integer;
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Result := Self._Quantity;
end;

procedure OrderItem.set_Quantity(Value: Integer);
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Self._Quantity := Value;
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
end;

function OrderItem.get__OwningOrder: Order;
begin
  Result := (CoreClassesUnit.Order(Self._content.get_MemberByIndex((OrderItemFirstMember 
      + 3))));
end;

procedure OrderItem.set__OwningOrder(Value: Order);
begin
  Self._content.set_MemberByIndex((OrderItemFirstMember + 3), (System.Object(Value)));
end;

function OrderItem.get_OwningOrder: Order;
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Result := Self._OwningOrder;
end;

procedure OrderItem.set_OwningOrder(Value: Order);
begin
  Self._OwningOrder := Value;
end;

constructor OrderItem.OrderItemListAdapter.Create(source: IList);
begin
  inherited Create(source);
end;

function OrderItem.OrderItemListAdapter.Add(value: OrderItem): Integer;
begin
  Result := Self.Adaptee.Add(value);
end;

function OrderItem.OrderItemListAdapter.Contains(value: OrderItem): Boolean;
begin
  Result := Self.Adaptee.Contains(value);
end;

function OrderItem.OrderItemListAdapter.IndexOf(value: OrderItem): Integer;
begin
  Result := Self.Adaptee.IndexOf(value);
end;

procedure OrderItem.OrderItemListAdapter.Insert(index: Integer; value: OrderItem);
begin
  Self.Adaptee.Insert(index, value);
end;

procedure OrderItem.OrderItemListAdapter.Remove(value: OrderItem);
begin
  Self.Adaptee.Remove(value);
end;

function OrderItem.OrderItemListAdapter.get_Item(index: Integer): OrderItem;
begin
  Result := OrderItem(Adaptee[index]);
end;

procedure OrderItem.OrderItemListAdapter.set_Item(index: Integer; value: OrderItem);
begin
  Adaptee[index] := value;
end;

{ CoreClasses }




















{ CoreClasses }
















end.
