unit MyFirstECOAppEcoSpace;

interface

uses
  System.Threading,
  Borland.Eco.Services,
  Borland.Eco.UmlCodeAttributes,
  Borland.Eco.Handles,
  CoreClassesUnit, Borland.Eco.Persistence.Interbase, 
  Borland.Eco.Persistence.Default, Borland.Eco.Persistence.Configuration, 
  Borland.Eco.Persistence, Borland.Data.Provider;

type
  [EcoSpace]
  [EcoSpacePackage(TypeOf(CoreClassesUnit.CoreClasses))]
  TMyFirstECOAppEcoSpace = class(Borland.Eco.Handles.DefaultEcoSpace)
  strict private
    PersistenceMapperBdp1: Borland.Eco.Persistence.PersistenceMapperBdp;
    BdpConnection1: Borland.Data.Provider.BdpConnection;
    procedure InitializeComponent;
    class var fTypeSystemProvider: ITypeSystemService;
    class var fTypeSystemProviderLock: Tobject;
  strict protected
    function GetTypeSystemProvider: ITypeSystemService; override;
  public
    constructor Create;
    class constructor Create;
    class function GetTypeSystemService: ITypeSystemService; static;
    procedure UpdateDatabase;
    function get_PersistenceService: IPersistenceService;
    property PersistenceService: IPersistenceService read get_PersistenceService;
    function get_DirtyListService: IDirtyListService;
    property DirtyListService: IDirtyListService read get_DirtyListService;
    function get_UndoService: IUndoService;
    property UndoService: IUndoService read get_UndoService;
    function get_TypeSystemService: ITypeSystemService;
    property TypeSystemService: ITypeSystemService read get_TypeSystemService;
    function get_OclService: IOclService;
    property OclService: IOclService read get_OclService;
    function get_ObjectFactoryService: IObjectFactoryService;
    property ObjectFactoryService: IObjectFactoryService read get_ObjectFactoryService;
    function get_VariableFactoryService: IVariableFactoryService;
    property VariableFactoryService: IVariableFactoryService read get_VariableFactoryService;
  end;

implementation
{$AUTOBOX ON}

constructor TMyFirstECOAppEcoSpace.Create;
begin
  inherited Create;
  InitializeComponent;
  // TODO: Add any constructor code here
end;

class constructor TMyFirstECOAppEcoSpace.Create;
begin
  fTypeSystemProviderLock := TObject.Create;
end;

class function TMyFirstECOAppEcoSpace.GetTypeSystemService: ITypeSystemService;
begin
  if not Assigned(fTypeSystemProvider) then
  begin
    try
      Monitor.Enter(fTypeSystemProviderLock);
      if not Assigned(fTypeSystemProvider) then
        fTypeSystemProvider := MakeTypeService(typeOf(TMyFirstECOAppEcoSpace));
    finally
      Monitor.Exit(fTypeSystemProviderLock);
    end;
  end;
  Result := fTypeSystemProvider;
end;

function TMyFirstECOAppEcoSpace.GetTypeSystemProvider: ITypeSystemService;
begin
  Result := TMyFirstECOAppEcoSpace.GetTypeSystemService;
end;

procedure TMyFirstECOAppEcoSpace.UpdateDatabase;
begin
  if Assigned(PersistenceService) and Assigned(DirtyListService) then
    PersistenceService.UpdateDatabaseWithList(DirtyListService.AllDirtyObjects);
end;

function TMyFirstECOAppEcoSpace.get_PersistenceService: IPersistenceService;
begin
  Result := GetEcoService(typeof(IPersistenceService)) as IPersistenceService;
end;

function TMyFirstECOAppEcoSpace.get_DirtyListService: IDirtyListService;
begin
  Result := GetEcoService(typeof(IDirtyListService)) as IDirtyListService;
end;

function TMyFirstECOAppEcoSpace.get_UndoService: IUndoService;
begin
  Result := GetEcoService(typeof(IUndoService)) as IUndoService;
end;

function TMyFirstECOAppEcoSpace.get_TypeSystemService: ITypeSystemService;
begin
  Result := GetEcoService(typeof(ITypeSystemService)) as ITypeSystemService;
end;

function TMyFirstECOAppEcoSpace.get_OclService: IOclService;
begin
  Result := GetEcoService(typeof(IOclService)) as IOclService;
end;

function TMyFirstECOAppEcoSpace.get_ObjectFactoryService: IObjectFactoryService;
begin
  Result := GetEcoService(typeof(IObjectFactoryService)) as IObjectFactoryService;
end;

function TMyFirstECOAppEcoSpace.get_VariableFactoryService: IVariableFactoryService;
begin
  Result := GetEcoService(typeof(IVariableFactoryService)) as IVariableFactoryService;
end;

procedure TMyFirstECOAppEcoSpace.InitializeComponent;
type
  TArrayOfBorland_Eco_Persistence_Configuration_KeyMapperDefinition = array of Borland.Eco.Persistence.Configuration.KeyMapperDefinition;
  TArrayOfBorland_Eco_Persistence_Configuration_PersistenceMapperDefinition = array of Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition;
var
  PersistenceMapperDefinition118: Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition;
  PersistenceMapperDefinition117: Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition;
  PersistenceMapperDefinition116: Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition;
  PersistenceMapperDefinition115: Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition;
  PersistenceMapperDefinition114: Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition;
  PersistenceMapperDefinition113: Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition;
  PersistenceMapperDefinition112: Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition;
  PersistenceMapperDefinition111: Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition;
  PersistenceMapperDefinition110: Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition;
  PersistenceMapperDefinition19: Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition;
  PersistenceMapperDefinition18: Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition;
  PersistenceMapperDefinition17: Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition;
  PersistenceMapperDefinition16: Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition;
  PersistenceMapperDefinition15: Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition;
  PersistenceMapperDefinition14: Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition;
  PersistenceMapperDefinition13: Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition;
  PersistenceMapperDefinition12: Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition;
  PersistenceMapperDefinition11: Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition;
  KeyMapperDefinition15: Borland.Eco.Persistence.Configuration.KeyMapperDefinition;
  KeyMapperDefinition14: Borland.Eco.Persistence.Configuration.KeyMapperDefinition;
  KeyMapperDefinition13: Borland.Eco.Persistence.Configuration.KeyMapperDefinition;
  KeyMapperDefinition12: Borland.Eco.Persistence.Configuration.KeyMapperDefinition;
  KeyMapperDefinition11: Borland.Eco.Persistence.Configuration.KeyMapperDefinition;
begin
  KeyMapperDefinition11 := Borland.Eco.Persistence.Configuration.KeyMapperDefinition.Create;
  KeyMapperDefinition12 := Borland.Eco.Persistence.Configuration.KeyMapperDefinition.Create;
  KeyMapperDefinition13 := Borland.Eco.Persistence.Configuration.KeyMapperDefinition.Create;
  KeyMapperDefinition14 := Borland.Eco.Persistence.Configuration.KeyMapperDefinition.Create;
  KeyMapperDefinition15 := Borland.Eco.Persistence.Configuration.KeyMapperDefinition.Create;
  PersistenceMapperDefinition11 := Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition.Create;
  PersistenceMapperDefinition12 := Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition.Create;
  PersistenceMapperDefinition13 := Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition.Create;
  PersistenceMapperDefinition14 := Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition.Create;
  PersistenceMapperDefinition15 := Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition.Create;
  PersistenceMapperDefinition16 := Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition.Create;
  PersistenceMapperDefinition17 := Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition.Create;
  PersistenceMapperDefinition18 := Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition.Create;
  PersistenceMapperDefinition19 := Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition.Create;
  PersistenceMapperDefinition110 := Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition.Create;
  PersistenceMapperDefinition111 := Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition.Create;
  PersistenceMapperDefinition112 := Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition.Create;
  PersistenceMapperDefinition113 := Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition.Create;
  PersistenceMapperDefinition114 := Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition.Create;
  PersistenceMapperDefinition115 := Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition.Create;
  PersistenceMapperDefinition116 := Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition.Create;
  PersistenceMapperDefinition117 := Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition.Create;
  PersistenceMapperDefinition118 := Borland.Eco.Persistence.Configuration.PersistenceMapperDefinition.Create;
  Self.PersistenceMapperBdp1 := Borland.Eco.Persistence.PersistenceMapperBdp.Create;
  Self.BdpConnection1 := Borland.Data.Provider.BdpConnection.Create;
  // 
  // PersistenceMapperBdp1
  // 
  Self.PersistenceMapperBdp1.Connection := Self.BdpConnection1;
  Self.PersistenceMapperBdp1.HistoryLength := 10000;
  Self.PersistenceMapperBdp1.SqlDatabaseConfig.DateTimeFormat := '"''"yyyy-M' +
  'M-dd"''"';
  Self.PersistenceMapperBdp1.SqlDatabaseConfig.DefaultDateTime := System.DateTime.Create((Int64(0)));
  Self.PersistenceMapperBdp1.SqlDatabaseConfig.DefaultStringLength := 255;
  Self.PersistenceMapperBdp1.SqlDatabaseConfig.DropColumnTemplate := 'ALTER ' +
  'TABLE <TableName> DROP <ColumnName>';
  Self.PersistenceMapperBdp1.SqlDatabaseConfig.DropIndexTemplate := 'DROP IN' +
  'DEX <IndexName>';
  Self.PersistenceMapperBdp1.SqlDatabaseConfig.DropTableTemplate := 'DROP TA' +
  'BLE <TableName>';
  Self.PersistenceMapperBdp1.SqlDatabaseConfig.FetchBlockSize := 250;
  KeyMapperDefinition11.Mapper := TypeOf(Borland.Eco.Persistence.DefaultEcoIdMapper);
  KeyMapperDefinition11.Name := 'DefaultEcoIdMapper';
  KeyMapperDefinition12.Mapper := TypeOf(Borland.Eco.Persistence.AttributeKeyMapper);
  KeyMapperDefinition12.Name := 'Attribute';
  KeyMapperDefinition13.Mapper := TypeOf(Borland.Eco.Persistence.AutoIncKeyMapper);
  KeyMapperDefinition13.Name := 'AutoInc';
  KeyMapperDefinition14.Mapper := TypeOf(Borland.Eco.Persistence.GuidKeyMapper);
  KeyMapperDefinition14.Name := 'Guid';
  KeyMapperDefinition15.Mapper := TypeOf(Borland.Eco.Persistence.AutoInc16KeyMapper);
  KeyMapperDefinition15.Name := 'AutoInc16';
  Self.PersistenceMapperBdp1.SqlDatabaseConfig.KeyMappers.AddRange(TArrayOfBorland_Eco_Persistence_Configuration_KeyMapperDefinition.Create(KeyMapperDefinition11, 
          KeyMapperDefinition12, KeyMapperDefinition13, KeyMapperDefinition14, 
          KeyMapperDefinition15));
  Self.PersistenceMapperBdp1.SqlDatabaseConfig.MaxDbIdentifierLength := 31;
  Self.PersistenceMapperBdp1.SqlDatabaseConfig.MaxIndexNameLength := 31;
  Self.PersistenceMapperBdp1.SqlDatabaseConfig.MaxParamsInIdList := 20;
  PersistenceMapperDefinition11.Mapper := TypeOf(Borland.Eco.Persistence.Default.StringAsVarChar);
  PersistenceMapperDefinition11.Name := 'System.String';
  PersistenceMapperDefinition12.Mapper := TypeOf(Borland.Eco.Persistence.Default.BooleanAsInteger);
  PersistenceMapperDefinition12.Name := 'System.Boolean';
  PersistenceMapperDefinition13.Mapper := TypeOf(Borland.Eco.Persistence.Default.BooleanAsYNChar);
  PersistenceMapperDefinition13.Name := 'BooleanAsYN';
  PersistenceMapperDefinition14.Mapper := TypeOf(Borland.Eco.Persistence.Default.Int32AsInteger);
  PersistenceMapperDefinition14.Name := 'System.Int32';
  PersistenceMapperDefinition15.Mapper := TypeOf(Borland.Eco.Persistence.Interbase.Int64AsLongInteger);
  PersistenceMapperDefinition15.Name := 'System.Int64';
  PersistenceMapperDefinition16.Mapper := TypeOf(Borland.Eco.Persistence.Default.Int16AsSmallint);
  PersistenceMapperDefinition16.Name := 'System.Int16';
  PersistenceMapperDefinition17.Mapper := TypeOf(Borland.Eco.Persistence.Default.ByteAsSmallInt);
  PersistenceMapperDefinition17.Name := 'System.Byte';
  PersistenceMapperDefinition18.Mapper := TypeOf(Borland.Eco.Persistence.Default.DoubleAsDouble);
  PersistenceMapperDefinition18.Name := 'System.Double';
  PersistenceMapperDefinition19.Mapper := TypeOf(Borland.Eco.Persistence.Default.SingleAsSingle);
  PersistenceMapperDefinition19.Name := 'System.Single';
  PersistenceMapperDefinition110.Mapper := TypeOf(Borland.Eco.Persistence.Default.CharAsChar);
  PersistenceMapperDefinition110.Name := 'System.Char';
  PersistenceMapperDefinition111.Mapper := TypeOf(Borland.Eco.Persistence.Interbase.DecimalAsDecimal);
  PersistenceMapperDefinition111.Name := 'System.Decimal';
  PersistenceMapperDefinition112.Mapper := TypeOf(Borland.Eco.Persistence.Default.DateTimeAsTimeStamp);
  PersistenceMapperDefinition112.Name := 'System.DateTime';
  PersistenceMapperDefinition113.Mapper := TypeOf(Borland.Eco.Persistence.Default.GuidAsVarChar32);
  PersistenceMapperDefinition113.Name := 'System.Guid';
  PersistenceMapperDefinition114.Mapper := TypeOf(Borland.Eco.Persistence.Interbase.ByteArrayAsBdpBlob);
  PersistenceMapperDefinition114.Name := 'System.Byte[]';
  PersistenceMapperDefinition115.Mapper := TypeOf(Borland.Eco.Persistence.Interbase.StringAsBdpBlob);
  PersistenceMapperDefinition115.Name := 'StringAsBlob';
  PersistenceMapperDefinition116.Mapper := TypeOf(Borland.Eco.Persistence.Default.TimeSpanAsTimeStamp);
  PersistenceMapperDefinition116.Name := 'System.TimeSpan';
  PersistenceMapperDefinition117.Mapper := TypeOf(Borland.Eco.Persistence.Interbase.Int32AsAutoInc);
  PersistenceMapperDefinition117.Name := 'AutoInc';
  PersistenceMapperDefinition118.Mapper := TypeOf(Borland.Eco.Persistence.Interbase.Int16AsAutoInc);
  PersistenceMapperDefinition118.Name := 'AutoInc16';
  Self.PersistenceMapperBdp1.SqlDatabaseConfig.PersistenceMappers.AddRange(TArrayOfBorland_Eco_Persistence_Configuration_PersistenceMapperDefinition.Create(PersistenceMapperDefinition11, 
          PersistenceMapperDefinition12, PersistenceMapperDefinition13, PersistenceMapperDefinition14, 
          PersistenceMapperDefinition15, PersistenceMapperDefinition16, PersistenceMapperDefinition17, 
          PersistenceMapperDefinition18, PersistenceMapperDefinition19, PersistenceMapperDefinition110, 
          PersistenceMapperDefinition111, PersistenceMapperDefinition112, PersistenceMapperDefinition113, 
          PersistenceMapperDefinition114, PersistenceMapperDefinition115, PersistenceMapperDefinition116, 
          PersistenceMapperDefinition117, PersistenceMapperDefinition118));
  Self.PersistenceMapperBdp1.SqlDatabaseConfig.ReservedWords := 'ABSOLUTE,AC' +
  'TION,ACTIVE,ADD,AFTER,ALL,ALLOCATE,ALTER,AND,ANY,ARE,AS,ASC,ASCENDING,ASS' +
  'ERTION,AT,AUTHORIZATION,AUTO,AUTOINC,AVG,BASE_NAME,BEFORE,BEGIN,BETWEEN,B' +
  'IT,BIT_LENGTH,BLOB,BOOLEAN,BOTH,BY,BYTES,CACHE,CASCADE,CASCADED,CASE,CAST' +
  ',CATALOG,CHAR,CHARACTER,CHARACTER_LENGTH,CHAR_LENGTH,CHECK,CHECK_POINT_LE' +
  'NGTH,CLOSE,COALESCE,COLLATE,COLLATION,COLUMN,COMMIT,COMMITTED,COMPUTED,CO' +
  'NDITIONAL,CONNECT,CONNECTION,CONSTRAINT,CONSTRAINTS,CONTAINING,CONTINUE,C' +
  'ONVERT,CORRESPONDING,COUNT,CREATE,CROSS,CSTRING,CURRENT,CURRENT_DATE,CURR' +
  'ENT_TIME,CURRENT_TIMESTAMP,CURRENT_USER,CURSOR,DATABASE,DATE,DAY,DB_KEY,D' +
  'EALLOCATE,DEBUG,DEC,DECIMAL,DECLARE,DEFAULT,DEFERRABLE,DEFERRED,DELETE,DE' +
  'SC,DESCENDING,DESCRIBE,DESCRIPTOR,DIAGNOSTICS,DISCONNECT,DISTINCT,DO,DOMA' +
  'IN,DOUBLE,DROP,ELSE,END,END-EXEC,ENTRY_POINT,ESCAPE,EXCEPT,EXCEPTION,EXEC' +
  ',EXECUTE,EXISTS,EXIT,EXTERNAL,EXTRACT,FALSE,FETCH,FILE,FILTER,FLOAT,FOR,F' +
  'OREIGN,FOUND,FROM,FULL,FUNCTION,GDSCODE,GENERATOR,GEN_ID,GET,GLOBAL,GO,GO' +
  'TO,GRANT,GROUP,GROUP_COMMIT_WAIT_TIME,HAVING,HOUR,IDENTITY,IF,IMMEDIATE,I' +
  'N,INACTIVE,INDEX,INDICATOR,INITIALLY,INNER,INPUT,INPUT_TYPE,INSENSITIVE,I' +
  'NSERT,INT,INTEGER,INTERSECT,INTERVAL,INTO,IS,ISOLATION,JOIN,KEY,LANGUAGE,' +
  'LAST,LEADING,LEFT,LENGTH,LEVEL,LIKE,LOCAL,LOGFILE,LOG_BUFFER_SIZE,LONG,LO' +
  'WER,MANUAL,MATCH,MAX,MAXIMUM_SEGMENT,MERGE,MESSAGE,MIN,MINUTE,MODULE,MODU' +
  'LE_NAME,MONEY,MONTH,NAMES,NATIONAL,NATURAL,NCHAR,NEXT,NO,NOT,NULL,NULLIF,' +
  'NUMERIC,NUM_LOG_BUFFERS,OCTET_LENGTH,OF,ON,ONLY,OPEN,OPTION,OR,ORDER,OUTE' +
  'R,OUTPUT,OUTPUT_TYPE,OVERFLOW,OVERLAPS,PAD,PAGE,PAGES,PAGE_SIZE,PARAMETER' +
  ',PARTIAL,PASSWORD,PLAN,POSITION,POST_EVENT,PRECISION,PREPARE,PRESERVE,PRI' +
  'MARY,PRIOR,PRIVILEGES,PROCEDURE,PROTECTED,PUBLIC,RAW_PARTITIONS,RD,READ,R' +
  'EAL,RECORD_VERSION,REFERENCES,RELATIVE,RESERV,RESERVING,RESTRICT,RETAIN,R' +
  'ETURNING_VALUES,RETURNS,REVOKE,RIGHT,ROLE,ROLLBACK,ROWS,SCHEMA,SCROLL,SEC' +
  'OND,SECTION,SEGMENT,SELECT,SESSION,SESSION_USER,SET,SHADOW,SHARED,SINGULA' +
  'R,SIZE,SMALLINT,SNAPSHOT,SOME,SORT,SPACE,SQL,SQLCODE,SQLERROR,SQLSTATE,SQ' +
  'LWARNING,STABILITY,STARTING,STARTS,STATISTICS,SUBSTRING,SUB_TYPE,SUM,SUSP' +
  'END,SYSTEM_USER,TABLE,TEMPORARY,THEN,TIME,TIMESTAMP,TIMEZONE_HOUR,TIMEZON' +
  'E_MINUTE,TO,TRAILING,TRANSACTION,TRANSLATE,TRANSLATION,TRIGGER,TRIM,TRUE,' +
  'UNCOMMITTED,UNION,UNIQUE,UNKNOWN,UPDATE,UPPER,USAGE,USER,USING,VALUE,VALU' +
  'ES,VARCHAR,VARIABLE,VARYING,VIEW,WAIT,WHEN,WHENEVER,WHERE,WHILE,WITH,WORK' +
  ',WRITE,YEAR,YES,ZONE,ACTIVE,ADMIN,AFTER,ASCENDING,AUTO,AUTODDL,BASED,BASE' +
  'NAME,BASE_NAME,BEFORE,BLOB,BLOBEDIT,BUFFER,CACHE,CHECK_POINT_LEN,CHECK_PO' +
  'INT_LENGTH,COMMITTED,COMPILETIME,COMPUTED,CONDITIONAL,CONTAINING,CSTRING,' +
  'DATABASE,DB_KEY,DEBUG,DESCENDING,DISPLAY,DO,ECHO,EDIT,ENTRY_POINT,EVENT,E' +
  'XIT,EXTERN,FILE,FILTER,FREE_IT,FUNCTION,GDSCODE,GENERATOR,GEN_ID,GROUP_CO' +
  'MMIT_WAIT,GROUP_COMMIT_WAIT_TIME,HELP,IF,INACTIVE,INDEX,INIT,INPUT_TYPE,I' +
  'SQL,LC_MESSAGES,LC_TYPE,LENGTH,LEV,LOGFILE,LOG_BUFFER_SIZE,LOG_BUF_SIZE,L' +
  'ONG,MANUAL,MAXIMUM,MAXIMUM_SEGMENT,MAX_SEGMENT,MERGE,MESSAGE,MINIMUM,MODU' +
  'LE_NAME,NOAUTO,NUM_LOG_BUFFERS,NUM_LOG_BUFS,OUTPUT_TYPE,OVERFLOW,PAGE,PAG' +
  'ELENGTH,PAGES,PAGE_SIZE,PARAMETER,PASSWORD,PLAN,POST_EVENT,QUIT,RAW_PARTI' +
  'TIONS,RDB$DB_KEY,RECORD_VERSION,RELEASE,RESERV,RESERVING,RETAIN,RETURN,RE' +
  'TURNING_VALUES,RETURNS,ROLE,RUNTIME,SECOND,SHADOW,SHARED,SHELL,SHOW,SINGU' +
  'LAR,SNAPSHOT,SORT,STABILITY,STARTING,STARTS,STATEMENT,STATIC,STATISTICS,S' +
  'UB_TYPE,SUSPEND,TERMINATOR,TRIGGER,TYPE,UNCOMMITTED,VARIABLE,VERSION,WAIT' +
  ',WEEKDAY,WHILE,YEARDAY';
  Self.PersistenceMapperBdp1.SqlDatabaseConfig.SQLforNotNull := 'NOT NULL';
  Self.PersistenceMapperBdp1.SqlDatabaseConfig.SqlScriptCommentStart := '/* ';
  Self.PersistenceMapperBdp1.SqlDatabaseConfig.SqlScriptCommentStop := ' */';
  Self.PersistenceMapperBdp1.SqlDatabaseConfig.SqlScriptCommitTransaction := 'C' +
  'OMMIT';
  Self.PersistenceMapperBdp1.SqlDatabaseConfig.SqlScriptRollBackTransaction := 'R' +
  'OLLBACK';
  Self.PersistenceMapperBdp1.SqlDatabaseConfig.SqlScriptSeparator := '---';
  Self.PersistenceMapperBdp1.SqlDatabaseConfig.SqlScriptStartTransaction := 'S' +
  'TART TRANSACTION';
  Self.PersistenceMapperBdp1.SqlDatabaseConfig.SqlScriptTerminator := ';';
  Self.PersistenceMapperBdp1.SqlDatabaseConfig.SupportsConstraintsInCreateTable := True;
  Self.PersistenceMapperBdp1.SqlDatabaseConfig.SystemTablePrefix := 'ECO';
  Self.PersistenceMapperBdp1.SqlDatabaseConfig.UseSQL92Joins := False;
  Self.PersistenceMapperBdp1.VersionGranularity := System.TimeSpan.Parse('00' +
    ':00:00');
  // 
  // BdpConnection1
  // 
  Self.BdpConnection1.ConnectionOptions := 'waitonlocks=False;transaction is' +
  'olation=ReadCommitted;commitretain=False;sqldialect=3;servercharset=;role' +
  'name=myrole';
  Self.BdpConnection1.ConnectionString := 'assembly=Borland.Data.Interbase,V' +
  'ersion=2.0.0.0,Culture=neutral,PublicKeyToken=91d62ebb5b0d1b1b;vendorclie' +
  'nt=gds32.dll;database=localhost:C:\ECODEMO.GDB;provider=Interbase;usernam' +
  'e=sysdba;password=masterkey';
  // 
  // TMyFirstECOAppEcoSpace
  // 
  Self.OptimisticLocking := True;
  Self.PersistenceMapper := Self.PersistenceMapperBdp1;
end;

end.
